import Emitter from '../utils/emitter';
import { AccessFriendParams, AccessGroupParams, AddFriendParams, AdvancedMsgParams, AdvancedQuoteMsgParams, AtMsgParams, ChangeGroupMemberMuteParams, ChangeGroupMuteParams, CreateGroupParams, CustomMsgParams, FaceMessageParams, FileMsgFullParams, FileMsgParams, FindMessageParams, GetAdvancedHistoryMsgParams, GetGroupMemberByTimeParams, GetGroupMemberParams, GetHistoryMsgParams, GetOneConversationParams, GetOneCveParams, GetSubDepParams, GroupInfoParams, GroupMsgReadParams, ImageMsgParams, InsertGroupMsgParams, InsertSingleMsgParams, InviteGroupParams, isRecvParams, JoinGroupParams, LocationMsgParams, LoginParam, MarkC2CParams, MarkNotiParams, MemberNameParams, MergerMsgParams, PartialUserItem, PinCveParams, QuoteMsgParams, RemarkFriendParams, RtcActionParams, SearchFriendParams, SearchGroupMemberParams, SearchGroupParams, SearchInOrzParams, SearchLocalParams, SendMsgParams, SetDraftParams, SetGroupRoleParams, SetGroupVerificationParams, SetMemberAuthParams, setPrvParams, SoundMsgParams, SouondMsgFullParams, SplitParams, TransferGroupParams, TypingUpdateParams, VideoMsgFullParams, VideoMsgParams } from '../types/params';
import { RtcInvite } from '../types/entity';
declare class SDK extends Emitter {
    private wasmInitializedPromise;
    private goExitPromise;
    private goExisted;
    constructor(url?: string);
    _invoker(functionName: string, func: (...args: any[]) => Promise<any>, args: any[], processor?: (data: string) => string): Promise<unknown>;
    login(params: LoginParam, operationID?: string): Promise<any>;
    logout(operationID?: string): Promise<unknown>;
    getAllConversationList(operationID?: string): Promise<unknown>;
    getOneConversation(params: GetOneConversationParams, operationID?: string): Promise<unknown>;
    getAdvancedHistoryMessageList: (params: GetAdvancedHistoryMsgParams, operationID?: string) => Promise<unknown>;
    getHistoryMessageList: (params: GetHistoryMsgParams, operationID?: string) => Promise<unknown>;
    getGroupsInfo(params: string[], operationID?: string): Promise<unknown>;
    deleteConversationFromLocalAndSvr(conversationID: string, operationID?: string): Promise<unknown>;
    markC2CMessageAsRead(params: MarkC2CParams, operationID?: string): Promise<unknown>;
    markMessageAsReadByConID(params: MarkNotiParams, operationID?: string): Promise<unknown>;
    markNotifyMessageHasRead(conversationID: string, operationID?: string): Promise<unknown>;
    getGroupMemberList(params: GetGroupMemberParams, operationID?: string): Promise<unknown>;
    createTextMessage(text: string, operationID?: string): Promise<unknown>;
    createImageMessage(params: ImageMsgParams, operationID?: string): Promise<unknown>;
    createCustomMessage(params: CustomMsgParams, operationID?: string): Promise<unknown>;
    createQuoteMessage(params: QuoteMsgParams, operationID?: string): Promise<unknown>;
    createAdvancedQuoteMessage(params: AdvancedQuoteMsgParams, operationID?: string): Promise<unknown>;
    createAdvancedTextMessage(params: AdvancedMsgParams, operationID?: string): Promise<unknown>;
    sendMessage(params: SendMsgParams, operationID?: string): Promise<unknown>;
    sendMessageNotOss(params: SendMsgParams, operationID?: string): Promise<unknown>;
    exportDB(operationID?: string): Promise<unknown>;
    getHistoryMessageListReverse(params: GetHistoryMsgParams, operationID?: string): Promise<unknown>;
    revokeMessage(params: string, operationID?: string): Promise<unknown>;
    setOneConversationPrivateChat(params: setPrvParams, operationID?: string): Promise<unknown>;
    getLoginStatus(operationID?: string): Promise<unknown>;
    getLoginUser(operationID?: string): Promise<unknown>;
    getSelfUserInfo(operationID?: string): Promise<unknown>;
    getUsersInfo(data: string[], operationID?: string): Promise<unknown>;
    setSelfInfo(data: PartialUserItem, operationID?: string): Promise<unknown>;
    createTextAtMessage(data: AtMsgParams, operationID?: string): Promise<unknown>;
    createSoundMessage(data: SoundMsgParams, operationID?: string): Promise<unknown>;
    createVideoMessage(data: VideoMsgParams, operationID?: string): Promise<unknown>;
    createFileMessage(data: FileMsgParams, operationID?: string): Promise<unknown>;
    createFileMessageFromFullPath(data: FileMsgFullParams, operationID?: string): Promise<unknown>;
    createImageMessageFromFullPath(data: string, operationID?: string): Promise<unknown>;
    createSoundMessageFromFullPath(data: SouondMsgFullParams, operationID?: string): Promise<unknown>;
    createVideoMessageFromFullPath(data: VideoMsgFullParams, operationID?: string): Promise<unknown>;
    createMergerMessage(data: MergerMsgParams, operationID?: string): Promise<unknown>;
    createForwardMessage(data: string, operationID?: string): Promise<unknown>;
    createFaceMessage(data: FaceMessageParams, operationID?: string): Promise<unknown>;
    createLocationMessage(data: LocationMsgParams, operationID?: string): Promise<unknown>;
    createCardMessage(data: string, operationID?: string): Promise<unknown>;
    deleteMessageFromLocalStorage(data: string, operationID?: string): Promise<unknown>;
    deleteMessageFromLocalAndSvr(data: string, operationID?: string): Promise<unknown>;
    deleteAllConversationFromLocal(operationID?: string): Promise<unknown>;
    deleteAllMsgFromLocal(operationID?: string): Promise<unknown>;
    deleteAllMsgFromLocalAndSvr(operationID?: string): Promise<unknown>;
    markGroupMessageHasRead(data: string, operationID?: string): Promise<unknown>;
    markGroupMessageAsRead(data: GroupMsgReadParams, operationID?: string): Promise<unknown>;
    insertSingleMessageToLocalStorage(data: InsertSingleMsgParams, operationID?: string): Promise<unknown>;
    insertGroupMessageToLocalStorage(data: InsertGroupMsgParams, operationID?: string): Promise<unknown>;
    typingStatusUpdate(data: TypingUpdateParams, operationID?: string): Promise<unknown>;
    clearC2CHistoryMessage(data: string, operationID?: string): Promise<unknown>;
    clearC2CHistoryMessageFromLocalAndSvr(data: string, operationID?: string): Promise<unknown>;
    clearGroupHistoryMessage(data: string, operationID?: string): Promise<unknown>;
    clearGroupHistoryMessageFromLocalAndSvr(data: string, operationID?: string): Promise<unknown>;
    getConversationListSplit(data: SplitParams, operationID?: string): Promise<unknown>;
    getConversationIDBySessionType(data: GetOneCveParams, operationID?: string): Promise<unknown>;
    getMultipleConversation(data: string[], operationID?: string): Promise<unknown>;
    deleteConversation(data: string, operationID?: string): Promise<unknown>;
    setConversationDraft(data: SetDraftParams, operationID?: string): Promise<unknown>;
    pinConversation(data: PinCveParams, operationID?: string): Promise<unknown>;
    getTotalUnreadMsgCount(operationID?: string): Promise<unknown>;
    getConversationRecvMessageOpt(data: string[], operationID?: string): Promise<unknown>;
    setConversationRecvMessageOpt(data: isRecvParams, operationID?: string): Promise<unknown>;
    searchLocalMessages(data: SearchLocalParams, operationID?: string): Promise<unknown>;
    addFriend(data: AddFriendParams, operationID?: string): Promise<unknown>;
    searchFriends(data: SearchFriendParams, operationID?: string): Promise<unknown>;
    getDesignatedFriendsInfo(data: string[], operationID?: string): Promise<unknown>;
    getRecvFriendApplicationList(operationID?: string): Promise<unknown>;
    getSendFriendApplicationList(operationID?: string): Promise<unknown>;
    getFriendList(operationID?: string): Promise<unknown>;
    setFriendRemark(data: RemarkFriendParams, operationID?: string): Promise<unknown>;
    checkFriend(data: string[], operationID?: string): Promise<unknown>;
    acceptFriendApplication: (data: AccessFriendParams, operationID?: string) => Promise<unknown>;
    refuseFriendApplication: (data: AccessFriendParams, operationID?: string) => Promise<unknown>;
    deleteFriend(data: string, operationID?: string): Promise<unknown>;
    addBlack(data: string, operationID?: string): Promise<unknown>;
    removeBlack(data: string, operationID?: string): Promise<unknown>;
    getBlackList(operationID?: string): Promise<unknown>;
    inviteUserToGroup(data: InviteGroupParams, operationID?: string): Promise<unknown>;
    kickGroupMember(data: InviteGroupParams, operationID?: string): Promise<unknown>;
    getGroupMembersInfo(data: Omit<InviteGroupParams, 'reason'>, operationID?: string): Promise<unknown>;
    getGroupMemberListByJoinTimeFilter(data: GetGroupMemberByTimeParams, operationID?: string): Promise<unknown>;
    searchGroupMembers(data: SearchGroupMemberParams, operationID?: string): Promise<unknown>;
    setGroupApplyMemberFriend(data: SetMemberAuthParams, operationID?: string): Promise<unknown>;
    setGroupLookMemberInfo(data: SetMemberAuthParams, operationID?: string): Promise<unknown>;
    getJoinedGroupList(operationID?: string): Promise<unknown>;
    createGroup(data: CreateGroupParams, operationID?: string): Promise<unknown>;
    setGroupInfo(data: GroupInfoParams, operationID?: string): Promise<unknown>;
    setGroupMemberNickname(data: MemberNameParams, operationID?: string): Promise<unknown>;
    joinGroup(data: JoinGroupParams, operationID?: string): Promise<unknown>;
    searchGroups(data: SearchGroupParams, operationID?: string): Promise<unknown>;
    quitGroup(data: string, operationID?: string): Promise<unknown>;
    dismissGroup(data: string, operationID?: string): Promise<unknown>;
    changeGroupMute(data: ChangeGroupMuteParams, operationID?: string): Promise<unknown>;
    changeGroupMemberMute(data: ChangeGroupMemberMuteParams, operationID?: string): Promise<unknown>;
    transferGroupOwner(data: TransferGroupParams, operationID?: string): Promise<unknown>;
    getSendGroupApplicationList(operationID?: string): Promise<unknown>;
    getRecvGroupApplicationList(operationID?: string): Promise<unknown>;
    acceptGroupApplication(data: AccessGroupParams, operationID?: string): Promise<unknown>;
    refuseGroupApplication(data: AccessGroupParams, operationID?: string): Promise<unknown>;
    signalingInvite(data: RtcInvite, operationID?: string): Promise<unknown>;
    signalingInviteInGroup(data: RtcInvite, operationID?: string): Promise<unknown>;
    signalingAccept(data: RtcActionParams, operationID?: string): Promise<unknown>;
    signalingReject(data: RtcActionParams, operationID?: string): Promise<unknown>;
    signalingCancel(data: RtcActionParams, operationID?: string): Promise<unknown>;
    signalingHungUp(data: RtcActionParams, operationID?: string): Promise<unknown>;
    getSubDepartment(data: GetSubDepParams, operationID?: string): Promise<unknown>;
    getDepartmentMember(data: GetSubDepParams, operationID?: string): Promise<unknown>;
    getUserInDepartment(userID: string, operationID?: string): Promise<unknown>;
    getDepartmentMemberAndSubDepartment(departmentID: string, operationID?: string): Promise<unknown>;
    getDepartmentInfo(departmentID: string, operationID?: string): Promise<unknown>;
    searchOrganization(data: SearchInOrzParams, operationID?: string): Promise<unknown>;
    resetConversationGroupAtType(data: string, operationID?: string): Promise<unknown>;
    setGroupMemberRoleLevel(data: SetGroupRoleParams, operationID?: string): Promise<unknown>;
    setGroupVerification(data: SetGroupVerificationParams, operationID?: string): Promise<unknown>;
    setGlobalRecvMessageOpt(data: {
        opt: OptType;
    }, operationID?: string): Promise<unknown>;
    newRevokeMessage(data: string, operationID?: string): Promise<unknown>;
    findMessageList(data: FindMessageParams, operationID?: string): Promise<unknown>;
}
export declare function getSDK(url?: string): SDK;
export {};
